/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/bwlist/ListPrivilegesResponse.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_BWLIST_LISTPRIVILEGESRESPONSE_HPP
#define CASTOR_BWLIST_LISTPRIVILEGESRESPONSE_HPP

// Include Files
#include "castor/rh/Response.hpp"
#include "osdep.h"
#include <iostream>
#include <string>
#include <vector>

namespace castor {

  // Forward declarations
  class ObjectSet;
  class IObject;

  namespace bwlist {

    // Forward declarations
    class Privilege;

    /**
     * class ListPrivilegesResponse
     * Response t \o a ListPrivilege request
     */
    class ListPrivilegesResponse : public virtual castor::rh::Response {

    public:

      /**
       * Empty Constructor
       */
      ListPrivilegesResponse() throw();

      /**
       * Empty Destructor
       */
      virtual ~ListPrivilegesResponse() throw();

      /**
       * Outputs this object in a human readable format
       * @param stream The stream where to print this object
       * @param indent The indentation to use
       * @param alreadyPrinted The set of objects already printed.
       * This is to avoid looping when printing circular dependencies
       */
      virtual void print(std::ostream& stream,
                         std::string indent,
                         castor::ObjectSet& alreadyPrinted) const;

      /**
       * Outputs this object in a human readable format
       */
      virtual void print() const;

      /**
       * Gets the type of this kind of objects
       */
      static int TYPE();

      /********************************************/
      /* Implementation of IObject abstract class */
      /********************************************/
      /**
       * Gets the type of the object
       */
      virtual int type() const;

      /**
       * virtual method to clone any object
       */
      virtual castor::IObject* clone();

      /*********************************/
      /* End of IObject abstract class */
      /*********************************/
      /**
       * Get the value of m_id
       * The id of this object
       * @return the value of m_id
       */
      u_signed64 id() const {
        return m_id;
      }

      /**
       * Set the value of m_id
       * The id of this object
       * @param new_var the new value of m_id
       */
      void setId(u_signed64 new_var) {
        m_id = new_var;
      }

      /**
       * Add a Privilege* object to the m_privilegesVector list
       */
      void addPrivileges(Privilege* add_object) {
        m_privilegesVector.push_back(add_object);
      }

      /**
       * Remove a Privilege* object from m_privilegesVector
       */
      void removePrivileges(Privilege* remove_object) {
        for (unsigned int i = 0; i < m_privilegesVector.size(); i++) {
          Privilege* item = m_privilegesVector[i];
          if (item == remove_object) {
            std::vector<Privilege*>::iterator it = m_privilegesVector.begin() + i;
            m_privilegesVector.erase(it);
            return;
          }
        }
      }

      /**
       * Get the list of Privilege* objects held by m_privilegesVector
       * @return list of Privilege* objects held by m_privilegesVector
       */
      std::vector<Privilege*>& privileges() {
        return m_privilegesVector;
      }

    private:

      /// The id of this object
      u_signed64 m_id;

      std::vector<Privilege*> m_privilegesVector;

    }; /* end of class ListPrivilegesResponse */

  } /* end of namespace bwlist */

} /* end of namespace castor */

#endif // CASTOR_BWLIST_LISTPRIVILEGESRESPONSE_HPP
