/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/stager/Disk2DiskCopyStartRequest.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_STAGER_DISK2DISKCOPYSTARTREQUEST_HPP
#define CASTOR_STAGER_DISK2DISKCOPYSTARTREQUEST_HPP

// Include Files
#include "castor/stager/Request.hpp"
#include "osdep.h"
#include <iostream>
#include <string>

namespace castor {

  // Forward declarations
  class ObjectSet;
  class IObject;

  namespace stager {

    /**
     * class Disk2DiskCopyStartRequest
     * Internal request for handling the start of StageDiskCopyReplicaRequest.
     */
    class Disk2DiskCopyStartRequest : public virtual Request {

    public:

      /**
       * Empty Constructor
       */
      Disk2DiskCopyStartRequest() throw();

      /**
       * Empty Destructor
       */
      virtual ~Disk2DiskCopyStartRequest() throw();

      /**
       * Outputs this object in a human readable format
       * @param stream The stream where to print this object
       * @param indent The indentation to use
       * @param alreadyPrinted The set of objects already printed.
       * This is to avoid looping when printing circular dependencies
       */
      virtual void print(std::ostream& stream,
                         std::string indent,
                         castor::ObjectSet& alreadyPrinted) const;

      /**
       * Outputs this object in a human readable format
       */
      virtual void print() const;

      /**
       * Gets the type of this kind of objects
       */
      static int TYPE();

      /********************************************/
      /* Implementation of IObject abstract class */
      /********************************************/
      /**
       * Gets the type of the object
       */
      virtual int type() const;

      /**
       * virtual method to clone any object
       */
      virtual castor::IObject* clone();

      /*********************************/
      /* End of IObject abstract class */
      /*********************************/
      /**
       * Get the value of m_diskCopyId
       * The id of the destination diskcopy
       * @return the value of m_diskCopyId
       */
      u_signed64 diskCopyId() const {
        return m_diskCopyId;
      }

      /**
       * Set the value of m_diskCopyId
       * The id of the destination diskcopy
       * @param new_var the new value of m_diskCopyId
       */
      void setDiskCopyId(u_signed64 new_var) {
        m_diskCopyId = new_var;
      }

      /**
       * Get the value of m_sourceDiskCopyId
       * The id of the source diskcopy
       * @return the value of m_sourceDiskCopyId
       */
      u_signed64 sourceDiskCopyId() const {
        return m_sourceDiskCopyId;
      }

      /**
       * Set the value of m_sourceDiskCopyId
       * The id of the source diskcopy
       * @param new_var the new value of m_sourceDiskCopyId
       */
      void setSourceDiskCopyId(u_signed64 new_var) {
        m_sourceDiskCopyId = new_var;
      }

      /**
       * Get the value of m_diskServer
       * The name of the destination diskserver.
       * @return the value of m_diskServer
       */
      std::string diskServer() const {
        return m_diskServer;
      }

      /**
       * Set the value of m_diskServer
       * The name of the destination diskserver.
       * @param new_var the new value of m_diskServer
       */
      void setDiskServer(std::string new_var) {
        m_diskServer = new_var;
      }

      /**
       * Get the value of m_mountPoint
       * The mount point on the destination diskserver.
       * @return the value of m_mountPoint
       */
      std::string mountPoint() const {
        return m_mountPoint;
      }

      /**
       * Set the value of m_mountPoint
       * The mount point on the destination diskserver.
       * @param new_var the new value of m_mountPoint
       */
      void setMountPoint(std::string new_var) {
        m_mountPoint = new_var;
      }

      /**
       * Get the value of m_fileId
       * The id of the castor file
       * @return the value of m_fileId
       */
      u_signed64 fileId() const {
        return m_fileId;
      }

      /**
       * Set the value of m_fileId
       * The id of the castor file
       * @param new_var the new value of m_fileId
       */
      void setFileId(u_signed64 new_var) {
        m_fileId = new_var;
      }

      /**
       * Get the value of m_nsHost
       * The name server hosting this castor file
       * @return the value of m_nsHost
       */
      std::string nsHost() const {
        return m_nsHost;
      }

      /**
       * Set the value of m_nsHost
       * The name server hosting this castor file
       * @param new_var the new value of m_nsHost
       */
      void setNsHost(std::string new_var) {
        m_nsHost = new_var;
      }

      /**
       * Get the value of m_id
       * The id of this object
       * @return the value of m_id
       */
      u_signed64 id() const {
        return m_id;
      }

      /**
       * Set the value of m_id
       * The id of this object
       * @param new_var the new value of m_id
       */
      void setId(u_signed64 new_var) {
        m_id = new_var;
      }

    private:

      /// The id of the destination diskcopy
      u_signed64 m_diskCopyId;

      /// The id of the source diskcopy
      u_signed64 m_sourceDiskCopyId;

      /// The name of the destination diskserver.
      std::string m_diskServer;

      /// The mount point on the destination diskserver.
      std::string m_mountPoint;

      /// The id of the castor file
      u_signed64 m_fileId;

      /// The name server hosting this castor file
      std::string m_nsHost;

      /// The id of this object
      u_signed64 m_id;

    }; /* end of class Disk2DiskCopyStartRequest */

  } /* end of namespace stager */

} /* end of namespace castor */

#endif // CASTOR_STAGER_DISK2DISKCOPYSTARTREQUEST_HPP
