/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/stager/NsFilesDeletedResponse.cpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

// Include Files
#include "castor/Constants.hpp"
#include "castor/IObject.hpp"
#include "castor/ObjectSet.hpp"
#include "castor/rh/Response.hpp"
#include "castor/stager/GCFile.hpp"
#include "castor/stager/NsFilesDeletedResponse.hpp"
#include "osdep.h"
#include <iostream>
#include <string>
#include <vector>

//------------------------------------------------------------------------------
// Constructor
//------------------------------------------------------------------------------
castor::stager::NsFilesDeletedResponse::NsFilesDeletedResponse() throw() :
  Response(),
  m_id(0) {
}

//------------------------------------------------------------------------------
// Destructor
//------------------------------------------------------------------------------
castor::stager::NsFilesDeletedResponse::~NsFilesDeletedResponse() throw() {
  for (unsigned int i = 0; i < m_orphanFileIdsVector.size(); i++) {
    delete m_orphanFileIdsVector[i];
  }
  m_orphanFileIdsVector.clear();
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::stager::NsFilesDeletedResponse::print(std::ostream& stream,
                                                   std::string indent,
                                                   castor::ObjectSet& alreadyPrinted) const {
  stream << indent << "[# NsFilesDeletedResponse #]" << std::endl;
  if (alreadyPrinted.find(this) != alreadyPrinted.end()) {
    // Circular dependency, this object was already printed
    stream << indent << "Back pointer, see above" << std::endl;
    return;
  }
  // Call print on the parent class(es)
  this->castor::rh::Response::print(stream, indent, alreadyPrinted);
  // Output of all members
  stream << indent << "id : " << m_id << std::endl;
  alreadyPrinted.insert(this);
  {
    stream << indent << "OrphanFileIds : " << std::endl;
    int i;
    std::vector<GCFile*>::const_iterator it;
    for (it = m_orphanFileIdsVector.begin(), i = 0;
         it != m_orphanFileIdsVector.end();
         it++, i++) {
      stream << indent << "  " << i << " :" << std::endl;
      (*it)->print(stream, indent + "    ", alreadyPrinted);
    }
  }
}

//------------------------------------------------------------------------------
// print
//------------------------------------------------------------------------------
void castor::stager::NsFilesDeletedResponse::print() const {
  castor::ObjectSet alreadyPrinted;
  print(std::cout, "", alreadyPrinted);
}

//------------------------------------------------------------------------------
// TYPE
//------------------------------------------------------------------------------
int castor::stager::NsFilesDeletedResponse::TYPE() {
  return OBJ_NsFilesDeletedResponse;
}

//------------------------------------------------------------------------------
// type
//------------------------------------------------------------------------------
int castor::stager::NsFilesDeletedResponse::type() const {
  return TYPE();
}

//------------------------------------------------------------------------------
// clone
//------------------------------------------------------------------------------
castor::IObject* castor::stager::NsFilesDeletedResponse::clone() {
  return new NsFilesDeletedResponse(*this);
}

