/**** This file has been autogenerated by gencastor from Umbrello UML model ***/

/******************************************************************************
 *                      castor/vdqm/TapeServer.hpp
 *
 * This file is part of the Castor project.
 * See http://castor.web.cern.ch/castor
 *
 * Copyright (C) 2003  CERN
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * @author Castor Dev team, castor-dev@cern.ch
 *****************************************************************************/

#ifndef CASTOR_VDQM_TAPESERVER_HPP
#define CASTOR_VDQM_TAPESERVER_HPP

// Include Files
#include "castor/IObject.hpp"
#include "castor/vdqm/TapeServerStatusCodes.hpp"
#include "osdep.h"
#include <iostream>
#include <string>
#include <vector>

namespace castor {

  // Forward declarations
  class ObjectSet;

  namespace vdqm {

    // Forward declarations
    class TapeDrive;

    /**
     * class TapeServer
     * Holds the information about the tape server. Every tape server has several tape
     * drives. If its actingMode says that it is in SERVER_INACTIVE, then its tape
     * drives are not involved in the CASTOR production.
     */
    class TapeServer : public virtual castor::IObject {

    public:

      /**
       * Empty Constructor
       */
      TapeServer() throw();

      /**
       * Empty Destructor
       */
      virtual ~TapeServer() throw();

      /**
       * Outputs this object in a human readable format
       * @param stream The stream where to print this object
       * @param indent The indentation to use
       * @param alreadyPrinted The set of objects already printed.
       * This is to avoid looping when printing circular dependencies
       */
      virtual void print(std::ostream& stream,
                         std::string indent,
                         castor::ObjectSet& alreadyPrinted) const;

      /**
       * Outputs this object in a human readable format
       */
      virtual void print() const;

      /**
       * Gets the type of this kind of objects
       */
      static int TYPE();

      /********************************************/
      /* Implementation of IObject abstract class */
      /********************************************/
      /**
       * Gets the type of the object
       */
      virtual int type() const;

      /**
       * virtual method to clone any object
       */
      virtual castor::IObject* clone();

      /*********************************/
      /* End of IObject abstract class */
      /*********************************/
      /**
       * Get the value of m_serverName
       * The name of the tape server
       * @return the value of m_serverName
       */
      std::string serverName() const {
        return m_serverName;
      }

      /**
       * Set the value of m_serverName
       * The name of the tape server
       * @param new_var the new value of m_serverName
       */
      void setServerName(std::string new_var) {
        m_serverName = new_var;
      }

      /**
       * Get the value of m_id
       * The id of this object
       * @return the value of m_id
       */
      u_signed64 id() const {
        return m_id;
      }

      /**
       * Set the value of m_id
       * The id of this object
       * @param new_var the new value of m_id
       */
      void setId(u_signed64 new_var) {
        m_id = new_var;
      }

      /**
       * Add a TapeDrive* object to the m_tapeDrivesVector list
       */
      void addTapeDrives(TapeDrive* add_object) {
        m_tapeDrivesVector.push_back(add_object);
      }

      /**
       * Remove a TapeDrive* object from m_tapeDrivesVector
       */
      void removeTapeDrives(TapeDrive* remove_object) {
        for (unsigned int i = 0; i < m_tapeDrivesVector.size(); i++) {
          TapeDrive* item = m_tapeDrivesVector[i];
          if (item == remove_object) {
            std::vector<TapeDrive*>::iterator it = m_tapeDrivesVector.begin() + i;
            m_tapeDrivesVector.erase(it);
            return;
          }
        }
      }

      /**
       * Get the list of TapeDrive* objects held by m_tapeDrivesVector
       * @return list of TapeDrive* objects held by m_tapeDrivesVector
       */
      std::vector<TapeDrive*>& tapeDrives() {
        return m_tapeDrivesVector;
      }

      /**
       * Get the value of m_actingMode
       * @return the value of m_actingMode
       */
      TapeServerStatusCodes actingMode() const {
        return m_actingMode;
      }

      /**
       * Set the value of m_actingMode
       * @param new_var the new value of m_actingMode
       */
      void setActingMode(TapeServerStatusCodes new_var) {
        m_actingMode = new_var;
      }

    private:

      /// The name of the tape server
      std::string m_serverName;

      /// The id of this object
      u_signed64 m_id;

      std::vector<TapeDrive*> m_tapeDrivesVector;

      TapeServerStatusCodes m_actingMode;

    }; /* end of class TapeServer */

  } /* end of namespace vdqm */

} /* end of namespace castor */

#endif // CASTOR_VDQM_TAPESERVER_HPP
